//
//  AntialiasEffect.h
//  AntialiasedRenderTexture
//
//  Created by Piotr on 02/11/16.
//
//

#ifndef __AntialiasEffect__
#define __AntialiasEffect__

#include "cocos2d.h"

USING_NS_CC;

class AntialiasedRenderTexture;

class AntialiasEffect : public Ref
{
public:
    static AntialiasEffect* create(Vec2 resolution, float blurRadius, float sampleNum);
    //static AntialiasEffect* create(Texture2D* uTexture, float resolution, float radius, Vec2 dir);
    GLProgramState* getGLProgramState() const { return _glprogramstate; }
    
protected:
    bool init(Vec2 resolution, float blurRadius, float sampleNum);
    //bool init(Texture2D* uTexture, float resolution, float radius, Vec2 dir);
    bool initGLProgramState(const std::string &fragmentFilename);
    AntialiasEffect();
    virtual ~AntialiasEffect();
    GLProgramState *_glprogramstate;
#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID || CC_TARGET_PLATFORM == CC_PLATFORM_WP8 || CC_TARGET_PLATFORM == CC_PLATFORM_WINRT)
    std::string _fragSource;
    EventListenerCustom* _backgroundListener;
#endif
};

#endif /* defined(__AntialiasEffect__) */
